# MPI_Win_get_attr

Get attribute cached on an MPI window object

## Synopsis

    int MPI_Win_get_attr(MPI_Win win, int win_keyval, void *attribute_val,
                        int *flag)

## Input Parameters

win
  window to which the attribute is attached (handle)
win_keyval
  key value (integer)

## Output Parameters

attribute_val
  attribute value, unless flag is false
flag
  false if no attribute is associated with the key (logical)

## Notes

The following attributes are predefined for all MPI Window objects:

MPI_WIN_BASE
  window base address.
MPI_WIN_SIZE
  window size, in bytes.
MPI_WIN_DISP_UNIT
  displacement unit associated with the window.

## Thread and Interrupt Safety

This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as `malloc` or other non-MPICH runtime routines that are themselves not interrupt-safe.

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_ERR_WIN
  Invalid MPI window object

MPI_ERR_KEYVAL
  Invalid keyval

MPI_ERR_OTHER
  Other error; use `MPI_Error_string` to get more information about this error code.

Location:win_get_attr.c